<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE Entity SYSTEM "jbo_03_01.dtd">
<!---->
<Entity
  xmlns="http://xmlns.oracle.com/bc4j"
  Name="Departments"
  Version="12.2.1.9.14"
  InheritPersonalization="merge"
  DBObjectType="table"
  DBObjectName="DEPARTMENTS"
  AliasName="Departments"
  BindingStyle="OracleName">
  <Attribute
    Name="DepartmentId"
    IsNotNull="true"
    Precision="4"
    Scale="0"
    ColumnName="DEPARTMENT_ID"
    SQLType="NUMERIC"
    Type="java.lang.Integer"
    ColumnType="NUMBER"
    TableName="DEPARTMENTS"
    PrimaryKey="true"/>
  <Attribute
    Name="DepartmentName"
    IsNotNull="true"
    Precision="30"
    ColumnName="DEPARTMENT_NAME"
    SQLType="VARCHAR"
    Type="java.lang.String"
    ColumnType="VARCHAR2"
    TableName="DEPARTMENTS">
    <DesignTime>
      <Attr Name="_DisplaySize" Value="30"/>
    </DesignTime>
  </Attribute>
  <Attribute
    Name="ManagerId"
    Precision="6"
    Scale="0"
    ColumnName="MANAGER_ID"
    SQLType="NUMERIC"
    Type="java.lang.Integer"
    ColumnType="NUMBER"
    TableName="DEPARTMENTS"/>
  <Attribute
    Name="LocationId"
    Precision="4"
    Scale="0"
    ColumnName="LOCATION_ID"
    SQLType="NUMERIC"
    Type="java.lang.Integer"
    ColumnType="NUMBER"
    TableName="DEPARTMENTS"/>
  <AccessorAttribute
    Name="Employees"
    Association="com.redsamurai.model.entities.assocs.DeptMgrFkAssoc"
    AssociationEnd="com.redsamurai.model.entities.assocs.DeptMgrFkAssoc.Employees"
    AssociationOtherEnd="com.redsamurai.model.entities.assocs.DeptMgrFkAssoc.Departments"
    Type="oracle.jbo.server.EntityImpl"
    IsUpdateable="true"/>
  <AccessorAttribute
    Name="Employees1"
    Association="com.redsamurai.model.entities.assocs.EmpDeptFkAssoc"
    AssociationEnd="com.redsamurai.model.entities.assocs.EmpDeptFkAssoc.Employees1"
    AssociationOtherEnd="com.redsamurai.model.entities.assocs.EmpDeptFkAssoc.Departments1"
    Type="oracle.jbo.RowIterator"
    IsUpdateable="false"/>
  <AccessorAttribute
    Name="JobHistory"
    Association="com.redsamurai.model.entities.assocs.JhistDeptFkAssoc"
    AssociationEnd="com.redsamurai.model.entities.assocs.JhistDeptFkAssoc.JobHistory"
    AssociationOtherEnd="com.redsamurai.model.entities.assocs.JhistDeptFkAssoc.Departments"
    Type="oracle.jbo.RowIterator"
    IsUpdateable="false"/>
  <AccessorAttribute
    Name="Locations"
    Association="com.redsamurai.model.entities.assocs.DeptLocFkAssoc"
    AssociationEnd="com.redsamurai.model.entities.assocs.DeptLocFkAssoc.Locations"
    AssociationOtherEnd="com.redsamurai.model.entities.assocs.DeptLocFkAssoc.Departments"
    Type="oracle.jbo.server.EntityImpl"
    IsUpdateable="true"/>
  <Key
    Name="DeptIdPk"
    PrimaryKey="true">
    <DesignTime>
      <Attr Name="_DBObjectName" Value="DEPT_ID_PK"/>
    </DesignTime>
    <AttrArray Name="Attributes">
      <Item Value="com.redsamurai.model.entities.Departments.DepartmentId"/>
    </AttrArray>
  </Key>
  <Key
    Name="DeptNameNn">
    <DesignTime>
      <Attr Name="_checkCondition" Value='"DEPARTMENT_NAME" IS NOT NULL'/>
      <Attr Name="_isCheck" Value="true"/>
      <Attr Name="_DBObjectName" Value="DEPT_NAME_NN"/>
    </DesignTime>
    <AttrArray Name="Attributes"/>
  </Key>
  <Key
    Name="DeptLocFk">
    <DesignTime>
      <Attr Name="_referencedKey" Value="LOC_ID_PK"/>
      <Attr Name="_isForeign" Value="true"/>
      <Attr Name="_DBObjectName" Value="DEPT_LOC_FK"/>
    </DesignTime>
    <AttrArray Name="Attributes">
      <Item Value="com.redsamurai.model.entities.Departments.LocationId"/>
    </AttrArray>
  </Key>
  <Key
    Name="DeptMgrFk">
    <DesignTime>
      <Attr Name="_referencedKey" Value="EMP_EMP_ID_PK"/>
      <Attr Name="_isForeign" Value="true"/>
      <Attr Name="_DBObjectName" Value="DEPT_MGR_FK"/>
    </DesignTime>
    <AttrArray Name="Attributes">
      <Item Value="com.redsamurai.model.entities.Departments.ManagerId"/>
    </AttrArray>
  </Key>
</Entity>
